/*
 * n01
 *
 * n01_practice.c
 *
 * Copyright (C) 1996-2005 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "../n01_plugin.h"
#include "Message.h"

#include "resource.h"

/* Define */

/* Global Variables */
HINSTANCE hInst;

/* Local Function Prototypes */

/*
 * DllMain - C
 */
int WINAPI DllMain(HINSTANCE hInstance, DWORD fdwReason, PVOID pvReserved)
{
	switch (fdwReason) {
	case DLL_PROCESS_ATTACH:
		hInst = hInstance;
		break;

	case DLL_PROCESS_DETACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}

/*
 * get_plugin_info - vOC擾
 *
 *	:
 *		hWnd - ĂяoEBhE
 *		index - 擾̃CfbNX (0`)
 *		pgi - vOC擾
 *
 *	߂l:
 *		TRUE - Ɏ擾vOC
 *		FALSE - 擾̏I
 */
__declspec(dllexport) BOOL CALLBACK get_plugin_info(const HWND hWnd, const int index, PLUGIN_GET_INFO *pgi)
{
	switch (index) {
	case 0:
		lstrcpy(pgi->title, TEXT("&Practice"));
		lstrcpy(pgi->func_name, TEXT("n01_practice"));
		lstrcpy(pgi->cmd_line, TEXT(""));
		return TRUE;

	case 1:
		return FALSE;
	}
	return FALSE;
}

/*
 * func_plugin_initialize - vOC̏
 *
 *	:
 *		hWnd - ĂяoEBhE
 *		pei - vOCs
 *
 *	߂l:
 *		vOČĂяo@
 *
 *	l:
 *		֐ vOC_initialize
 */
__declspec(dllexport) BOOL CALLBACK n01_practice_initialize(const HWND hWnd, PLUGIN_EXEC_INFO *pei)
{
	// ߂lɌĂяo@̑gݍ킹ݒ肷
	return (CALLTYPE_MENU | CALLTYPE_SET_START | CALLTYPE_INPUT_START);
}

/*
 * func_plugin - vOC
 *
 *	:
 *		hWnd - ĂяoEBhE
 *		call_type - Ăяo@
 *		pei - vOCs
 *		param - Ăяo
 *
 *	߂l:
 *		PLUGIN_
 */
__declspec(dllexport) int CALLBACK n01_practice(const HWND hWnd, const int call_type, PLUGIN_EXEC_INFO *pei, int param)
{
	int x, y;

	switch (call_type) {
	case CALLTYPE_MENU:
		// j[
		if (pei->lParam1 > 0 &&
			MessageBox(hWnd, message_get_res(IDS_STRING_PRACTICE_CANCEL), TEXT("Practice"), MB_ICONQUESTION | MB_YESNO) == IDYES) {
			pei->si->player[pei->lParam1 - 1].lock = FALSE;
			pei->lParam1 = 0;
			break;
		}
		if (MessageBox(hWnd, message_get_res(IDS_STRING_PRACTICE_MODE), TEXT("Practice"), MB_ICONINFORMATION | MB_OKCANCEL) == IDCANCEL) {
			break;
		}
		pei->lParam1 = 2;
		pei->si->player[pei->lParam1 - 1].lock = TRUE;
		break;

	case CALLTYPE_SET_START:
		// ZbgJn
		// param - ݂̃Zbg
		if (pei->lParam1 == 0) {
			break;
		}
		if (param == 0) {
			pei->lParam1 = 0;
		} else {
			pei->si->player[pei->lParam1 - 1].lock = TRUE;
		}
		break;

	case CALLTYPE_INPUT_START:
		// XRA͊Jn
		if (pei->lParam1 == 0) {
			break;
		}
		SendMessage(hWnd, WM_N01_GET_INPUT_POS, (WPARAM)&x, (LPARAM)&y);
		if (pei->si->player[x].lock != TRUE || x != (pei->lParam1 - 1)) {
			break;
		}
		if (pei->si->leg[pei->si->current_leg].current_round == y &&
			pei->si->leg[pei->si->current_leg].current_player == x) {
			pei->si->player[x].check_out_mode = FALSE;
			PostMessage(hWnd, WM_N01_SCORE_INPUT, 0, 0);
			return PLUGIN_CANCEL;
		}
		break;
	}
	return PLUGIN_SUCCEED;
}
/* End of source */
